/*
 * Red-Unida IRC Daemon
 * Copyright (C) 2004-2005 Micael Fernandez
 *
 *
 * Basado sobre el codigo de Jarkko Oikarinen, UnderNet y IRC-Hispano.
 *
 * Este programa es gratis, puedes redistribuirlo y modificarlo bajo los
 * terminos de la GNU.
 *
 */

 
 

#include "sys.h"
#include "h.h"
#include "s_debug.h"
#include "struct.h"
#include "numeric.h"
#include "send.h"
#include "match.h"
#include "list.h"
#include "errores.h"
#include "ircd.h"
#include "s_bsd.h"
#include "s_bdd.h"
#include "miscelanea.h"
#include "querycmds.h"
#include "map.h"
#include "numnicks.h"

RCSTAG_CC("$Id: map.c,v 1.1.1.1 1999/11/16 05:13:14 codercom Exp $");

static void dump_map(struct Client *cptr, struct Client *server, char *mask,
    int prompt_length)
{
  static char prompt[64];
  Dlink *lp;
  char *p = &prompt[prompt_length];
  int cnt = 0;
  int mostrar = 0;
  char buf[16], servername[32];

  *p = '\0';
  if (prompt_length > 60)
    sendto_one(cptr, rpl_str(RPL_MAPMORE), me.name, cptr->name,
        prompt, server->name);
  else
  {
    char lag[512];
    unsigned int clientes;
    unsigned int clientes_float;

    clientes = nrof.clients;
    if (!clientes)
      clientes = 1;             /* Evitamos division por cero */

    if (server->serv->lag > 10000)
      lag[0] = 0;
    else if (server->serv->lag < 0)
      strcpy(lag, "(0s)");
    else
      sprintf(lag, "(%is)", server->serv->lag);
    sprintf(buf, "%s:%d", NumServ(server), base64toint(NumServ(server)));
    clientes_float =
        (int)((1000.0 * (server ==
        &me ? nrof.local_clients : server->serv->clients)) / clientes + 0.5);

    if (ocultar_servidores_en_el_map && !(IsHelpOp(cptr) || IsAdmin(cptr) || (cptr->user->server->name == server->name))) {
	if (!buscar_uline(cptr->confs, server->name)) {
	   sprintf(servername, "*.%s", DOMAINNAME);
	   mostrar = 1;
	}
    } else {
       sprintf(servername, "%s", server->name);
       mostrar = 1;
    }

    if (mostrar)
       sendto_one(cptr, rpl_str(RPL_MAP), me.name, cptr->name, prompt,
        ((IsBurstOrBurstAck(server)) ? "*" : ""), servername, buf, lag,
        (server == &me) ? nrof.local_clients : server->serv->clients,
        clientes_float / 10, clientes_float % 10);
  }
  if (prompt_length > 0)
  {
    p[-1] = ' ';
    if (p[-2] == '`')
      p[-2] = ' ';
  }
  if (prompt_length > 60)
    return;
  strcpy(p, "|-");
  for (lp = server->serv->down; lp; lp = lp->next)
    if (match(mask, lp->value.cptr->name))
      lp->value.cptr->flags &= ~FLAGS_MAP;
    else
    {
      lp->value.cptr->flags |= FLAGS_MAP;
      cnt++;
    }
  for (lp = server->serv->down; lp; lp = lp->next)
  {
    if ((lp->value.cptr->flags & FLAGS_MAP) == 0)
      continue;
    if (--cnt == 0)
      *p = '`';
    dump_map(cptr, lp->value.cptr, mask, prompt_length + 2);
  }
  if (prompt_length > 0)
    p[-1] = '-';
}

/*
 * m_map  -- by Run
 *
 * parv[0] = sender prefix
 * parv[1] = server mask
 */
int m_map(aClient *UNUSED(cptr), aClient *sptr, int parc, char *parv[])
{
  if (parc < 2)
    parv[1] = "*";

  dump_map(sptr, &me, parv[1], 0);
  sendto_one(sptr, rpl_str(RPL_MAPEND), me.name, parv[0]);

  return 0;
}
