/*
 * Red-Unida IRC Daemon
 * Copyright (C) 2004-2005 Micael Fernandez
 *
 *
 * Basado sobre el codigo de Jarkko Oikarinen, UnderNet y IRC-Hispano.
 *
 * Este programa es gratis, puedes redistribuirlo y modificarlo bajo los
 * terminos de la GNU.
 *
 */

#include "runmalloc.h"
#include "slab_alloc.h"

#include <string.h>


char *SlabStringAlloc(size_t size)
{
  return RunMalloc(size);
}

void SlabStringAllocDup(char **old, char *new, size_t max_len)
{
  int len;

  if (*old)
    RunFree(*old);

  len = strlen(new);
  if ((!max_len) || (len <= max_len))
  {
    *old = RunMalloc(len + 1);
    strcpy(*old, new);
    return;
  }

/* Nos pasamos de taman~o */
  *old = RunMalloc(max_len + 1);
  strncpy(*old, new, max_len);
  (*old)[max_len] = '\0';
}

void SlabStringFree(char *string)
{
  RunFree(string);
}
